\ProvidesPackage{beamerthemeSCITAS}[]

\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage{tikz}
\usepackage{xifthen}
\usepackage{listings}


% ------------------------------------------------------------------------------
% Theme definitions
% ------------------------------------------------------------------------------
% Set backgrounds
\setbeamertemplate{background}{%
  \ifnum\c@framenumber=0%First slide
  \includegraphics[width=\paperwidth,height=\paperheight]{images/Intro2Clusters_background_v.pdf}
  \else%Other slides
  \includegraphics[width=\paperwidth,height=\paperheight]{images/Intro2Clusters_background_v.pdf}
  \fi%
}

\setbeamertemplate{frametitle}[default][center]%center titles

\setbeamertemplate{footline}{
  \leavevmode%
  \hbox{%
  \ifnum\c@framenumber>0%not first slide
  \begin{beamercolorbox}[wd=\paperwidth,ht=0ex,dp=2ex,center]{page number in head/foot}%
    \usebeamerfont{page number in head/foot}
    \hspace{3cm}\insertframenumber{} / \inserttotalframenumber%
      \hspace{1.5cm}\href{http://creativecommons.org/licenses/by-sa/4.0/}{\includegraphics[scale=.4]{images/cc-shared-alike4}}
  \end{beamercolorbox}
  \else%
  \begin{beamercolorbox}[wd=\paperwidth,ht=0ex,dp=2ex,center]{page number in head/foot}%
    \usebeamerfont{page number in head/foot}
    \hspace{1.5cm}\href{http://creativecommons.org/licenses/by-sa/4.0/}{\includegraphics[scale=.4]{images/cc-shared-alike4}}
  \end{beamercolorbox}
  \fi}\vskip0pt%
}


\let\otp\titlepage
%\renewcommand{\titlepage}{\otp\addtocounter{framenumber}{-1}}

% Set some specific colors
\setbeamercolor {structure}{fg=black}
\setbeamercolor*{titlelike}{fg=black}

% \setbeamertemplate{navigation symbols}{} % remove navigation symbols
\setbeamersize{text margin left=40pt,text margin right=15pt}
\useinnertheme{rounded}

\setbeamercolor{block title}{fg=blue,bg=blue!30}
\setbeamercolor{block body}{bg=normal text.bg!90!black}

\definecolor{BrickRed}{HTML}{B6321C}
\setbeamercolor{block title alerted}{fg=BrickRed,bg=BrickRed!30}
\setbeamercolor{block body alerted}{fg=black,bg=BrickRed!10}

\definecolor{OliveGreen}{HTML}{3C8031}
\setbeamercolor{block title example}{fg=OliveGreen,bg=OliveGreen!30}
\setbeamercolor{block body example}{fg=black,bg=OliveGreen!10}


\setbeamertemplate{navigation symbols}{}%remove navigation symbols
\setbeamertemplate{frametitle}[default][center]%center titles

\addtobeamertemplate{block begin}
  {}
  {\addtolength{\leftskip}{0em}   %%% awful hack for left/right padding
   \addtolength{\rightskip}{1em}} %%% that doesn't even work right

% ------------------------------------------------------------------------------
% Color definitions
% ------------------------------------------------------------------------------
\definecolor{colKeys}{rgb}{0,0,1}
\definecolor{colIdentifier}{rgb}{0,0,0}
\definecolor{colComments}{rgb}{0,.5,0}
\definecolor{colString}{rgb}{1,0,0}
\definecolor{colCppBg}{HTML}{F5EDE4}
\definecolor{colShellBg}{HTML}{F5EDE4}

% ------------------------------------------------------------------------------
% Listing definitions
% ------------------------------------------------------------------------------
\lstdefinestyle{lstDefaultStyle} {
  backgroundcolor=\color{colCppBg},
  frame=tb,
  framexleftmargin=2pt,
  framextopmargin=0pt,
  framexbottommargin=0pt,
  framerule=0pt,
  xleftmargin=0.5cm,xrightmargin=0.5cm,
  showstringspaces=false, % underline spaces within strings
  tabsize=4, % sets default tabsize to 2 spaces
  captionpos=b, % sets the caption-position to bottom
  columns=flexible,
  keepspaces=true,
  mathescape=false,
  escapechar=\%,
  breaklines=true, % sets automatic line breaking
  breakatwhitespace=false,   % sets if  automatic breaks  should only  happen at
}

% Create a new list style for C++
\lstdefinestyle{myC++}{
  language=C++, % the language of the code
  style=lstDefaultStyle,
  basicstyle=\small\ttfamily, % Without beramono, we'd get cmtt, the teletype font.
  commentstyle=\color{colComments}\itshape,
  keywordstyle=\color{DarkOrchid}\bfseries,
  morekeywords={Real, UInt, Int}
}

% Create new list style for cmake files
\lstdefinelanguage{cmake}{
  morekeywords={project, cmake\_minimum\_required, enable\_language, message,
    add\_executable, add\_library, target\_link\_libraries, include\_directories,
    find\_package, find\_path, find\_library, include, mark\_as\_advanced,
    find\_package\_handle\_standard\_args},
  morecomment=[l]{\#},
  sensitive=false,
  morestring=[b]'',
}

\lstdefinestyle{mycmake}{
  language=cmake, % the language of the code
  style=lstDefaultStyle,
  basicstyle=\ttfamily, % Without beramono, we'd get cmtt, the teletype font.
  commentstyle=\color{colComments}\itshape,
  keywordstyle=\color{RoyalBlue}\bfseries,
  stringstyle=\color{colString}, %
  mathescape=false
}

% Create new list style for cmake files
\lstdefinestyle{mymake}{
  language=make, % the language of the code
  style=lstDefaultStyle,
  basicstyle=\ttfamily, % Without beramono, we'd get cmtt, the teletype font.
  commentstyle=\color{colComments}\itshape,
  keywordstyle=\color{RoyalBlue}\bfseries,
  stringstyle=\color{colString}, %
  mathescape=false
}

% Create new list style for the shell
\lstdefinestyle{myshell}{
  backgroundcolor=\color{colShellBg},
  keywordstyle=\color{colKeys}, %
  stringstyle=\color{colString}, %
  commentstyle=\color{colComments}, %
  language=bash, % the language of the code
  style=lstDefaultStyle,
  basicstyle=\scriptsize\ttfamily, % Without beramono, we'd get cmtt, the teletype font.
  morekeywords={mkdir, make, ccmake, cmake, module, srun},
  keepspaces=false
}


\lstdefinestyle{mypython}{
  language=Python,
  basicstyle=\ttfamily, %
  style=lstDefaultStyle,
  identifierstyle=\color{colIdentifier}, %
  keywordstyle=\color{colKeys}, %
  stringstyle=\color{colString}, %
  commentstyle=\color{colComments}, %
  frame=single, %
  extendedchars=true, %
  showtabs=true,
  numbers=left, %
  numberstyle=\tiny, %
  breakautoindent=true %
}

% Set some derived listing environments
\lstnewenvironment{python}{\lstset{style=mypython}}{}
\lstnewenvironment{cpp}{\lstset{style=myC++}}{}
\lstnewenvironment{command}{\lstset{style=myshell}}{}
\lstnewenvironment{cmake}{\lstset{style=mycmake}}{}

\newcommand{\includecode}[2][c]{\lstinputlisting[style=my#1]{#2}}

\newcommand{\mybox}[2][fill=colShellBg]{%
  \tikz[baseline=-0.5ex] \node at (0,0) [#1,draw,inner sep=2pt]{#2};}

\newcommand{\code}[1]{\mybox{\texttt{#1}}}
